//
//  MediaControls.m
//  Pianopub
//
//  Created by Remi Bernotavicius on 8/25/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MediaControls.h"


@implementation MediaControls

-(id)init
{
	if((self = [super init]))
	{
		if([[NSUserDefaults standardUserDefaults] boolForKey:@"appleremote"])
		{
			remote = [[AppleRemote alloc] initWithDelegate:self];
			[remote setDelegate:self];
			[remote startListening:self];
		}
		[self listenForKeyEvents];
	}
	return self;
}

-(void)dealloc
{
	[remote release];
	[super dealloc];
}

- (void) sendRemoteButtonEvent: (RemoteControlEventIdentifier) event pressedDown: (BOOL) pressedDown remoteControl: (RemoteControl*) remoteControl
{
	if(pressedDown)
	{
		if(event == kRemoteButtonPlay)
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(pausePlay:)];
		else if(event == kRemoteButtonRight)
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(next:)];
		else if(event == kRemoteButtonPlus)
		{
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(volumeUp)];
			remoteButtonDown = [[NSDate date] timeIntervalSince1970];
			[self performSelector:@selector(upLoop) withObject:nil afterDelay:1];
		}
		else if(event == kRemoteButtonMinus)
		{
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(volumeDown)];
			remoteButtonDown = [[NSDate date] timeIntervalSince1970];
			[self performSelector:@selector(downLoop) withObject:nil afterDelay:1];
		}
	}
	else
		remoteButtonDown = [[NSDate date] timeIntervalSince1970];
}

-(void)upLoop
{
	if([[NSDate date] timeIntervalSince1970] - remoteButtonDown >= 1)
	{
		[[[NSApplication sharedApplication] delegate] performSelector:@selector(volumeUp)];
		[self performSelector:@selector(upLoop) withObject:nil afterDelay:0.1];
	}
}

-(void)downLoop
{
	if([[NSDate date] timeIntervalSince1970] - remoteButtonDown >= 1)
	{
		[[[NSApplication sharedApplication] delegate] performSelector:@selector(volumeDown)];
		[self performSelector:@selector(downLoop) withObject:nil afterDelay:0.1];
	}
}

CGEventRef
myCGEventCallback(CGEventTapProxy proxy, CGEventType type,
                  CGEventRef event, void *refcon)
{
	// Paranoid sanity check.
	if ((type != kCGEventKeyDown) && (type != kCGEventKeyUp) && (type !=
																 NX_SYSDEFINED))
		return event;
	
	NSEvent *e = [NSEvent eventWithCGEvent:event];
	
	
	// We're getting a special event
	if( ([e type] == NSSystemDefined && [e subtype] == 8) ) {
		// do whatever you do with special events
		// return NULL to kill the event
		// we're getting a normal key event
		//NSLog(@"%@", e);
		if([e data1] == 1051392 || [e data1] == 1248000)
			return NULL;
		
		if([e data1] == 1051136)
		{
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(pausePlay:)];
			return NULL;
		}
		else if([e data1] == 1247744)
		{
			[[[NSApplication sharedApplication] delegate] performSelector:@selector(next:)]; 
			return NULL;
		}
		
	} else if([e type] == NSKeyDown || [e type] == NSKeyUp) {
		// do whatever you do with regular events
		// return NULL to kill the event
	}
	
	return event;
}

- (void)listenForKeyEvents
{
	CFMachPortRef      eventTap;//, eventTapTest;
	CGEventMask        eventMask;
	CFRunLoopSourceRef runLoopSource;
	
	eventMask = ((1 << kCGEventKeyDown) | (1 << kCGEventKeyUp));
	
	/*
	// try creating an event tap just for keypresses. if it fails, we need Universal Access.
	eventTapTest = CGEventTapCreate(kCGSessionEventTap,
									kCGHeadInsertEventTap, 0,
									eventMask, myCGEventCallback, NULL);
	if (!eventTapTest) {
		NSLog(@"no tap");
		NSAlert *alert = [[[NSAlert alloc] init] autorelease];
		[alert addButtonWithTitle:@"Quit"];
		[alert setMessageText:@"Media Key Support not enabled"];
		[alert setInformativeText:@"Please enable \"access for assistive devices\" in the Universal Access pane of System Preferences in order to support media keys"];
		[alert setAlertStyle:NSCriticalAlertStyle];
		[alert runModal];
		[NSApp terminate:self];
		return;
	}
	// disable the test tap
	// causes a crash otherwise (infinite loop with the replacement events, probably)
	CGEventTapEnable(eventTapTest, false);*/
	
	// Create an event tap. We are interested in key presses and system defined keys.
	eventTap = CGEventTapCreate(kCGSessionEventTap,
								kCGHeadInsertEventTap, 0,
								CGEventMaskBit(NX_SYSDEFINED) | eventMask, myCGEventCallback,
								NULL);
	
	// Create a run loop source.
	runLoopSource = CFMachPortCreateRunLoopSource(
												  kCFAllocatorDefault, eventTap, 0);
	
	// Add to the current run loop.
	CFRunLoopAddSource(CFRunLoopGetCurrent(), runLoopSource,
					   kCFRunLoopCommonModes);
	
	// Enable the event tap.
	CGEventTapEnable(eventTap, true);
	
}

@end
