//
//  Pianobar.h
//  pianobarCocoa
//
//  Created by Remi Bernotavicius on 8/25/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

/* system includes */
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/select.h>
#include <time.h>
#include <ctype.h>
/* open () */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
/* tcset/getattr () */
#include <termios.h>
#include <pthread.h>
#include <assert.h>

/* pandora.com library */
#include "piano.h"

#include "main.h"
#include "terminal.h"
#include "config.h"
#include "ui.h"
#include "ui_act.h"
#include "ui_readline.h"

@protocol PianobarDelegate

-(void)songDidStart:(NSDictionary*)songInfo;
-(void)positionUpdate:(int)position duration:(int)duration;
-(void)connectionDidExpire;

@end

@interface Pianobar : NSObject {
	
	BarApp_t app;

	int currentStation;
	bool playing;
	id <PianobarDelegate> delegate;
}

-(id)initWithUsername:(NSString*)username andPassword:(NSString*)password quality:(PianoAudioFormat_t)quality error:(NSString**)_error;
-(BOOL)loveSong;
-(NSArray*)searchForMusicQuery:(NSString*)query isArtist:(BOOL)_artist;
-(NSArray*)getSuggestions;
-(NSString*)getSongExplanation;
-(BOOL)bookmarkCurrentArtist;
-(BOOL)bookmarkCurrentSong;
-(NSArray*)upcomingSongs;
-(BOOL)addSharedStationById:(NSString*)_id;
-(BOOL)playing;
-(void)setVolume:(int)level;

-(BOOL)deleteStationWithId:(NSString*)_id;
-(BOOL)createStationById:(NSString*)_id;
-(BOOL)addMusicToCurrentStationById:(NSString*)_id;
-(BOOL)banSong;
-(NSArray*)getStations;
-(void)nextSong;
-(void)playpause;
-(void)selectStationById:(NSString*)_id;
-(void)startStreaming;
-(void)setDelegate:(id <PianobarDelegate>)anObject;
-(void)stopStreaming;

@end
