//
//  PianopubAppDelegate.h
//  Pianopub
//
//  Created by Remi Bernotavicius on 8/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Pianobar.h"
#import "MediaControls.h"
#import <Growl/Growl.h>

@interface PianopubAppDelegate : NSObject <PianobarDelegate, GrowlApplicationBridgeDelegate, NSApplicationDelegate> {
    IBOutlet NSWindow* window;
	IBOutlet NSWindow* addStationWindow;
	IBOutlet NSWindow* loginWindow;
	
	IBOutlet NSArrayController* stationsController;
	IBOutlet NSArrayController* searchResultsController;
	IBOutlet NSArrayController* startupStationsController;
	
	IBOutlet NSView* stationsView;
	
	IBOutlet NSSlider* volumeSlider;
	
	Pianobar* _pianobar;
	NSMutableDictionary* songInformation;
	NSMutableArray* stations;
	NSMutableDictionary* trackInformation;
	NSMutableDictionary* loginInformation;
	MediaControls* controlManager;
	NSMutableArray* searchResults;
	
	
}

-(NSMutableDictionary*)songInformation;
-(NSMutableDictionary*)trackInformation;
-(NSMutableDictionary*)loginInformation;
-(NSMutableArray*)stations;
-(NSMutableArray*)searchResults;

-(void)updateStations;
-(void)updatePlaying;
-(void)clearInformation;
-(void)sendNotification;

-(IBAction)pausePlay:(id)sender;
-(IBAction)next:(id)sender;
-(IBAction)loveSong:(id)sender;
-(IBAction)banSong:(id)sender;
-(IBAction)deleteStation:(id)sender;
-(IBAction)search:(id)sender;
-(IBAction)addStation:(id)sender;
-(IBAction)hideStations:(id)sender;
-(IBAction)login:(id)sender;
-(IBAction)logout:(id)sender;
-(IBAction)changeStartupStation:(id)sender;
-(IBAction)cancelLogin:(id)sender;
-(IBAction)explainSong:(id)sender;
-(IBAction)volumeChange:(id)sender;
-(IBAction)bookmarkSong:(id)sender;
-(IBAction)bookmarkArtist:(id)sender;
-(void)volumeUp;
-(void)volumeDown;
@end
